#!/bin/sh

# Please run this from primary node.

SECONDARY_NODE_IP="192.168.122.107"

collect_drbdstat_verbose()
{
  (while :; do date;drbdsetup status --verbose --statistics; sleep 1; done >> collect_drbdstat_verbose.log) &
}


drbd_discon_con()
{
  date;

  ssh root@"${SECONDARY_NODE_IP}" drbdadm disconnect r0
  echo "sec : drbdadm disconnect r0 ret=$?"

  sleep 1

  ssh root@"${SECONDARY_NODE_IP}" drbdadm connect r0
  echo "sec : drbdadm connect r0 ret=$?"

  sleep $1

  umount /mnt/drbd
  echo "umount ret=$?"
  mount /dev/drbd0 /mnt/drbd
  echo "mount ret=$?"

  for i in {1..600}
  do
    echo "`date` LOOP=$i"
    peerdisk=`drbdsetup status --verbose --statistics | grep -w peer-disk:UpToDate | wc -l`
echo "peerdisk="${peerdisk}""
# DBG    echo "peerdisk="${peerdisk}""
    if [ "${peerdisk}" -ne 0 ]; then
      echo "peer-disk:UpToDate !! break i=$i"
      break
    fi
    sleep 1
  done

  outofsync=`drbdsetup status --verbose --statistics | grep -w out-of-sync:0 | wc -l`
  if [ ${outofsync} -eq 0 ]; then
    echo "out-of-sync=not 0 !! (abnormal)"
    kill -9 ${collectpid}
    exit 1
  fi
  echo "out-of-sync:0 !!"
  sleep 1.0
}

echo "#############################################################################" >> collect_drbdstat_verbose.log
collect_drbdstat_verbose
collectpid=$!
echo "collectpid = ${collectpid}"

while :;
do
  drbd_discon_con 1.0
  drbd_discon_con 0.9
  drbd_discon_con 0.8
  drbd_discon_con 0.7
  drbd_discon_con 0.6
  drbd_discon_con 0.5
  drbd_discon_con 0.4
  drbd_discon_con 0.3
  drbd_discon_con 0.2
  drbd_discon_con 0.1
  drbd_discon_con 0.0
done

kill -9 ${collectpid}
